{
  This demo requires importing "Shockwave Flash" ActiveX

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ShockwaveFlashObjects_TLB, StdCtrls, RVStyle, RVScroll,
  RichView, RVEdit, RVItem, RVTypes;

type
  TForm1 = class(TForm)
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    GroupBox1: TGroupBox;
    txtURL: TEdit;
    Label1: TLabel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RichViewEdit1SaveComponentToFile(Sender: TCustomRichView;
      Path: TRVUnicodeString; SaveMe: TPersistent; SaveFormat: TRVSaveFormat;
      var OutStr: TRVUnicodeString);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

function GetVideoId(const URL: String): String;
var
  URLLower: String;
  p: Integer;
const
  http = 'http://';
  https = 'https://';
  test1 = 'www.youtube.com/';
  test2 = 'youtube.com/';
  videoidpref = 'watch?v=';
begin
  Result := '';
  URLLower := AnsiLowerCase(URL);
  if Copy(URLLower, 1, Length(http)) = http then
    URLLower := Copy(URLLower, Length(http) + 1, MaxInt)
  else if Copy(URLLower, 1, Length(https)) = https then
    URLLower := Copy(URLLower, Length(https) + 1, MaxInt);
  if (Copy(URLLower, 1, Length(test1))<>test1) and
     (Copy(URLLower, 1, Length(test2))<>test2) then
    exit;
  p := Pos(videoidpref, URL);
  if p=0 then
    exit;
  Result := Copy(URL, p+Length(videoidpref), Length(URL));
  p := pos('&', Result);
  if p<>0 then
    Result := Copy(Result, 1, p-1);
end;


{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var VideoID: String;
    swf: TShockWaveFlash;
begin
  VideoID := GetVideoId(txtURL.Text);
  if VideoID='' then begin
    Beep;
    exit;
  end;
  swf := TShockWaveFlash.Create(nil);
  // the control size is hard-coded here as 620x440
  // the user can resize it using the mouse after selecting it
  swf.Width := 620;
  swf.Height := 440;
  RichViewEdit1.TopLevelEditor.BeginUndoGroup(rvutInsert);
  RichViewEdit1.TopLevelEditor.SetUndoGroupMode(True);
  try
    if RichViewEdit1.InsertControl('', swf, rvvaBaseline) then
    begin
      RichViewEdit1.SetCurrentItemExtraIntProperty(rvepResizable, 1, True);
      swf.Movie := 'https://www.youtube.com/v/' + VideoID;
    end;
  finally
    RichViewEdit1.TopLevelEditor.SetUndoGroupMode(False);
  end;
end;

// preventing problems when destroing TRichViewEdit while movies are played
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  RichViewEdit1.Clear;
end;

procedure TForm1.RichViewEdit1SaveComponentToFile(Sender: TCustomRichView;
  Path: TRVUnicodeString; SaveMe: TPersistent; SaveFormat: TRVSaveFormat;
  var OutStr: TRVUnicodeString);
var VideoID: String;
begin
  VideoID := GetVideoId(txtURL.Text);
  if (SaveFormat=rvsfHTML) and (SaveMe is TShockwaveFlash) then
  begin
     OutStr := Format(
       '<object width="%d" height="%d">'+
        '<param name="movie" value="%s"></param>'+
        '<param name="allowFullScreen" value="true"></param>'+
        '<param name="allowscriptaccess" value="always"></param>'+
        '<embed src="%s" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="%d" height="%d"></embed>'+
       '</object>',
         [TShockwaveFlash(SaveMe).Width, TShockwaveFlash(SaveMe).Height,
          TShockwaveFlash(SaveMe).Movie,
          TShockwaveFlash(SaveMe).Movie,          
          TShockwaveFlash(SaveMe).Width, TShockwaveFlash(SaveMe).Height]);
  end;
end;

initialization
  RegisterClass(TShockwaveFlash);

end.
